
/* array of all defined inputs to SQLGetInfo
 * source: ODBC 3.5 Developers Guide by Roger E Sanders ISBN 0-07-058087-1
 * author: Dennis Box, dbox@fnal.gov
 * $Id: SQLGetInfoIn.h,v 1.2 2002/05/31 19:54:59 dbox Exp $
 */




SQLUSMALLINT getInfoOpts[] = {
SQL_ACCESSIBLE_PROCEDURES,
SQL_ACCESSIBLE_TABLES,
SQL_ACTIVE_ENVIRONMENTS,
SQL_AGGREGATE_FUNCTIONS,
SQL_ALTER_DOMAIN,
SQL_ALTER_TABLE,
SQL_ASYNC_MODE,
SQL_BATCH_ROW_COUNT,
SQL_BATCH_SUPPORT,
SQL_BOOKMARK_PERSISTENCE,
SQL_CATALOG_LOCATION,
SQL_CATALOG_NAME,
SQL_CATALOG_NAME_SEPARATOR,
SQL_CATALOG_TERM,
SQL_CATALOG_USAGE,
SQL_COLLATION_SEQ,
SQL_COLUMN_ALIAS,
SQL_CONCAT_NULL_BEHAVIOR,
SQL_CONVERT_BIGINT,
SQL_CONVERT_BINARY,
SQL_CONVERT_BIT,
SQL_CONVERT_CHAR,
SQL_CONVERT_DATE,
SQL_CONVERT_DECIMAL,
SQL_CONVERT_DOUBLE,
SQL_CONVERT_FLOAT,
SQL_CONVERT_FUNCTIONS,
SQL_CONVERT_INTEGER,
SQL_CONVERT_INTERVAL_DAY_TIME,
SQL_CONVERT_INTERVAL_YEAR_MONTH,
SQL_CONVERT_LONGVARBINARY,
SQL_CONVERT_LONGVARCHAR,
SQL_CONVERT_NUMERIC,
SQL_CONVERT_REAL,
SQL_CONVERT_SMALLINT,
SQL_CONVERT_TIME,
SQL_CONVERT_TIMESTAMP,
SQL_CONVERT_TINYINT,
SQL_CONVERT_VARBINARY,
SQL_CONVERT_VARCHAR,
SQL_CONVERT_WCHAR,
SQL_CONVERT_WLONGVARCHAR,
SQL_CONVERT_WVARCHAR,
SQL_CORRELATION_NAME,
SQL_CREATE_ASSERTION,
SQL_CREATE_CHARACTER_SET,
SQL_CREATE_COLLATION,
SQL_CREATE_DOMAIN,
SQL_CREATE_SCHEMA,
SQL_CREATE_TABLE,
SQL_CREATE_TRANSLATION,
SQL_CREATE_VIEW,
SQL_CURSOR_COMMIT_BEHAVIOR,
SQL_CURSOR_ROLLBACK_BEHAVIOR,
SQL_CURSOR_SENSITIVITY,
SQL_DATA_SOURCE_NAME,
SQL_DATA_SOURCE_READ_ONLY,
SQL_DATABASE_NAME,
SQL_DATETIME_LITERALS,
SQL_DBMS_NAME,
SQL_DBMS_VER,
SQL_DDL_INDEX,
SQL_DESCRIBE_PARAMETER,
SQL_DM_VER,
SQL_DRIVER_HDBC,
SQL_DRIVER_HDESC,
SQL_DRIVER_HENV,
SQL_DRIVER_HLIB,
SQL_DRIVER_HSTMT,
SQL_DRIVER_NAME,
SQL_DRIVER_ODBC_VER,
SQL_DRIVER_VER,
SQL_DROP_ASSERTION,
SQL_DROP_CHARACTER_SET,
SQL_DROP_COLLATION,
SQL_DROP_DOMAIN,
SQL_DROP_SCHEMA,
SQL_DROP_TABLE,
SQL_DROP_TRANSLATION,
SQL_DROP_VIEW,
SQL_DYNAMIC_CURSOR_ATTRIBUTES1,
SQL_DYNAMIC_CURSOR_ATTRIBUTES2,
SQL_EXPRESSIONS_IN_ORDERBY,
SQL_FILE_USAGE,
SQL_FETCH_DIRECTION,
SQL_FORWARD_ONLY_CURSOR_ATTRIBUTES1,
SQL_FORWARD_ONLY_CURSOR_ATTRIBUTES2,
SQL_GETDATA_EXTENSIONS,
SQL_GROUP_BY,
SQL_IDENTIFIER_CASE,
SQL_IDENTIFIER_QUOTE_CHAR,
SQL_INDEX_KEYWORDS,
SQL_INFO_SCHEMA_VIEWS,
SQL_INSERT_STATEMENT,
SQL_INTEGRITY,
SQL_KEYSET_CURSOR_ATTRIBUTES1,
SQL_KEYSET_CURSOR_ATTRIBUTES2,
SQL_KEYWORDS,
SQL_LIKE_ESCAPE_CLAUSE,
SQL_LOCK_TYPES,
SQL_MAX_ASYNC_CONCURRENT_STATEMENTS,
SQL_MAX_BINARY_LITERAL_LEN,
SQL_MAX_CATALOG_NAME_LEN,
SQL_MAX_CHAR_LITERAL_LEN,
SQL_MAX_COLUMN_NAME_LEN,
SQL_MAX_COLUMNS_IN_GROUP_BY,
SQL_MAX_COLUMNS_IN_INDEX,
SQL_MAX_COLUMNS_IN_ORDER_BY,
SQL_MAX_COLUMNS_IN_SELECT,
SQL_MAX_COLUMNS_IN_TABLE,
SQL_MAX_CONCURRENT_ACTIVITIES,
SQL_MAX_CURSOR_NAME_LEN,
SQL_MAX_DRIVER_CONNECTIONS,
SQL_MAX_IDENTIFIER_LEN,
SQL_MAX_INDEX_SIZE,
SQL_MAX_LENGTH,
SQL_MAX_PROCEDURE_NAME_LEN,
SQL_MAX_ROW_SIZE,
SQL_MAX_ROW_SIZE_INCLUDES_LONG,
SQL_MAX_SCHEMA_NAME_LEN,
SQL_MAX_STATEMENT_LEN,
SQL_MAX_TABLE_NAME_LEN,
SQL_MAX_TABLES_IN_SELECT,
SQL_MAX_USER_NAME_LEN,
SQL_MULT_RESULT_SETS,
SQL_MULTIPLE_ACTIVE_TXN,
SQL_NEED_LONG_DATA_LEN,
SQL_NON_NULLABLE_COLUMNS,
SQL_NULL_COLLATION,
SQL_NUMERIC_FUNCTIONS,
SQL_ODBC_API_CONFORMANCE,
SQL_ODBC_INTERFACE_CONFORMANCE,
SQL_ODBC_SQL_CONFORMANCE,
SQL_OJ_CAPABILITIES,
SQL_ORDER_BY_COLUMNS_IN_SELECT,
SQL_PARAM_ARRAY_ROW_COUNTS,
SQL_PARAM_ARRAY_SELECTS,
SQL_POS_OPERATIONS,
SQL_POSITIONED_STATEMENTS,
SQL_PROCEDURES,
SQL_PROCEDURE_TERM,
SQL_QUOTED_IDENTIFIER_CASE,
SQL_ROW_UPDATES,
SQL_SCHEMA_TERM,
SQL_SCHEMA_USAGE,
SQL_SCROLL_CONCURRENCY,
SQL_SCROLL_OPTIONS,
SQL_SEARCH_PATTERN_ESCAPE,
SQL_SERVER_NAME,
SQL_SPECIAL_CHARACTERS,
SQL_SQL_CONFORMANCE,
SQL_SQL92_DATETIME_FUNCTIONS,
SQL_SQL92_FOREIGN_KEY_DELETE_RULE,
SQL_SQL92_FOREIGN_KEY_UPDATE_RULE,
SQL_SQL92_GRANT,
SQL_SQL92_NUMERIC_VALUE_FUNCTIONS,
SQL_SQL92_PREDICATES,
SQL_SQL92_RELATIONAL_JOIN_OPERATORS,
SQL_SQL92_REVOKE,
SQL_SQL92_ROW_VALUE_CONSTRUCTOR,
SQL_SQL92_STRING_FUNCTIONS,
SQL_SQL92_VALUE_EXPRESSIONS,
SQL_STANDARD_CLI_CONFORMANCE,
SQL_STATIC_CURSOR_ATTRIBUTES1,
SQL_STATIC_CURSOR_ATTRIBUTES2,
SQL_STATIC_SENSITIVITY,
SQL_STRING_FUNCTIONS,
SQL_SUBQUERIES,
SQL_SYSTEM_FUNCTIONS,
SQL_TABLE_TERM,
SQL_TIMEDATE_ADD_INTERVALS,
SQL_TIMEDATE_DIFF_INTERVALS,
SQL_TIMEDATE_FUNCTIONS,
SQL_TXN_CAPABLE,
SQL_TXN_ISOLATION_OPTION,
SQL_UNION,
SQL_USER_NAME,
SQL_XOPEN_CLI_YEAR
};
#define getInfoOptsSIZE sizeof(getInfoOpts)/sizeof(getInfoOpts[0]) 
